<?php

namespace App\Entity;

use App\Repository\CounterRepository;
use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: CounterRepository::class)]
class Counter
{
    public const STATE_READY = "ready";
    public const STATE_STARTED = "started";
    public const STATE_COMPLETED = "completed";

    public const TRANSITION_TO_STARTED = "to_started";
    public const TRANSITION_TO_COMPLETED = "to_completed";
    public const TRANSITION_TO_READY = "to_ready";

    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column(type: Types::DATETIME_IMMUTABLE, nullable: true)]
    private ?\DateTimeImmutable $startTime = null;

    #[ORM\Column(type: Types::DATETIME_IMMUTABLE, nullable: true)]
    private ?\DateTimeImmutable $endTime = null;

    #[ORM\Column(length: 255, nullable: true)]
    private ?string $name = null;

    #[ORM\Column(length: 255)]
    private ?string $state = null;

    #[ORM\Column(length: 255)]
    private ?string $timeToLive = null;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getStartTime(): ?\DateTimeImmutable
    {
        return $this->startTime;
    }

    public function setStartTime(?\DateTimeImmutable $startTime): static
    {
        $this->startTime = $startTime;

        return $this;
    }

    public function getEndTime(): ?\DateTimeImmutable
    {
        return $this->endTime;
    }

    public function setEndTime(?\DateTimeImmutable $endTime): static
    {
        $this->endTime = $endTime;

        return $this;
    }

    public function getName(): ?string
    {
        return $this->name;
    }

    public function setName(?string $name): static
    {
        $this->name = $name;

        return $this;
    }

    public function getState(): ?string
    {
        return $this->state;
    }

    public function setState(string $state): static
    {
        $this->state = $state;

        return $this;
    }

    public function getTimeTolive(): ?string
    {
        return $this->timeToLive;
    }

    public function setTimeTolive(string $timeTolive): static
    {
        $this->timeToLive = $timeTolive;

        return $this;
    }

    public function getMinutes(): int
    {
        return (int) filter_var($this->timeToLive, FILTER_SANITIZE_NUMBER_INT) ?? 0;
    }
}
