<?php

namespace App\Form;

use App\Entity\Counter;
use App\Form\DataTransformer\MinutesToPeriodTransformer;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\IntegerType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class CounterType extends AbstractType
{
    public function __construct(protected MinutesToPeriodTransformer $minutesToPeriodTransormer)
    {
        
    }
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('name')
            ->add('timeToLive', IntegerType::class)
        ;
        $builder->get('timeToLive')
            ->addModelTransformer($this->minutesToPeriodTransormer)
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Counter::class,
        ]);
    }
}
